oracle.pg.hbase

## Class OracleEdge

- java.lang.Object
- - oracle.pg.hbase.OracleElement
  - - oracle.pg.hbase.OracleEdge

- All Implemented Interfaces:
    Edge, Element, MesgConsts, OracleEdgeBase, OracleElementBase

      public class OracleEdge
      extends OracleElement
      implements OracleEdgeBase, MesgConsts

  This class implements the Blueprints Edge and Element interfaces on top of the Apache HBase database.

- - ### Field Summary

    - ### Fields inherited from interface oracle.pg.common.MesgConsts

      `ERR_ARG_CANNOT_BE_NULL, ERR_CODE_NOT_IN_LIST, ERR_DOP_CONSTRAINT, ERR_E_DS_MUSTBE_FILE_OR_IS, ERR_E_MAX_LINE_CONSTRAINT, ERR_EDGE_DIR_NOT_BOTH, ERR_GRAPH_NAME_CANT_BENULL, ERR_HIT_EXCEPTION, ERR_HIT_INTERRUPT, ERR_HIT_IO, ERR_HIT_OPGE, ERR_HIT_PARSEE, ERR_ID_CANNOT_BE_NULL, ERR_IDX_KEY_CANNOT_BE_NULL, ERR_IN_DS_EDGE_CANTBE_NULL, ERR_IN_DS_VERT_CANTBE_NULL, ERR_IN_E_FLAT_DOESNT_EXIST, ERR_IN_V_FLAT_DOESNT_EXIST, ERR_INVALID_NUM_FIELDS, ERR_INVALID_NUM_NOARG, ERR_INVALID_NUMBER, ERR_INVALID_VAL, ERR_KEY_CANNOT_BE_ID, ERR_KEY_CANNOT_BE_NULL, ERR_KEY_NOT_SET_TO, ERR_NO_ELEM_TO_BE_CONSUMED, ERR_NO_OP_SUPPORTED, ERR_NOT_IMPLEMENTED_YET, ERR_NOT_ORACLE_V_E, ERR_NUM_PART_CONSTRAINT, ERR_OFFSET_CONSTRAINT, ERR_OFFSET_E_MUST_BE_POS, ERR_OFFSET_V_MUST_BE_POS, ERR_PG_ALREADY_EXISTS, ERR_PG_NOT_EMPTY, ERR_SIZE_MUST_BE_POS, ERR_TIMEOUT_TAB_CREATION, ERR_TYPE_ID_NOT_RECO, ERR_UNSUPPORTED_VAL_TYP, ERR_USER_REQ_OP_CANCEL, ERR_V_DS_MUSTBE_FILE_OR_IS, ERR_V_MAX_LINE_CONSTRAINT, ERR_VALUE_CANNOT_BE_NULL, INFO_EMP_K_NO_P_VAL, INFO_NUL_K_NO_P_VAL`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `equals(Object o)` This method returns true if the current OracleEdge instance is considered equal to the given OracleEdge instance
    `void` | `forceRefresh()` Physically refresh this Edge instance by reading from the underlying database
    `static OracleEdge` | `getInstance(OraclePropertyGraph opg, Long eid)` Returns an instance of OracleEdge
    `static OracleEdge` | `getInstance(OraclePropertyGraph opg, Long eid, boolean bCreateIfAbsentFromCache)` Returns an instance of OracleEdge.
    `static OracleEdge` | `getInstance(OraclePropertyGraph opg, Long eid, boolean bCreateIfAbsentFromCache, boolean bSkipStoreToCache)` Returns an instance of OracleEdge.
    `static OracleEdge` | `getInstance(OraclePropertyGraph opg, Long eid, String label)` Returns an instance of OracleEdge
    `static OracleEdge` | `getInstance(OraclePropertyGraph opg, Long eid, String label, boolean bCreateIfAbsentFromCache)` Returns an instance of OracleEdge.
    `static OracleEdge` | `getInstance(OraclePropertyGraph opg, Long eid, String label, boolean bCreateIfAbsentFromCache, boolean bSkipStoreToCache)` Returns an instance of OracleEdge.
    `static OracleEdge` | `getInstance(OraclePropertyGraph opg, OracleVertexBase outVertex, OracleVertexBase inVertex, Long eid, boolean bCreateIfAbsentFromCache, boolean bSkipStoreToCache)` Returns an instance of OracleEdge
    `static OracleEdge` | `getInstance(OraclePropertyGraph opg, OracleVertexBase outVertex, OracleVertexBase inVertex, String edgeLabel, Long eid)` Returns an instance of OracleEdge
    `static OracleEdge` | `getInstance(OraclePropertyGraph opg, OracleVertexBase outVertex, OracleVertexBase inVertex, String edgeLabel, Long eid, boolean bCreateIfAbsentFromCache)` Returns an instance of OracleEdge
    `static OracleEdge` | `getInstance(OraclePropertyGraph opg, OracleVertexBase outVertex, OracleVertexBase inVertex, String edgeLabel, Long eid, boolean bCreateIfAbsentFromCache, boolean bSkipStoreToCache)` Returns an instance of OracleEdge
    `OracleVertex` | `getInVertex()` This is a bit more convenient than the getVertex API that uses Direction.
    `Object` | `getInVertexID()` Return the incoming vertex Object.
    `String` | `getLabel()` Return the label associated with the edge.
    `OracleVertex` | `getOutVertex()` This is a bit more convenient than the getVertex API that uses Direction.
    `Object` | `getOutVertexID()` Return the outgoing vertex Object.
    `Vertex` | `getVertex(Direction direction)` Return the tail/out or head/in vertex.
    `int` | `hashCode()` This method returns the hash code
    `void` | `remove()` This method removes this OracleEdge instance from its owning OraclePropertyGraph instance
    `void` | `setProperty(String key, Object value)` Assign a key/value property to the element.
    `void` | `setProperty(String key, Object value, boolean skipQueue)` Assign a key/value property to the element.
    `String` | `toString()` Returns a String representation of the Edge

    - ### Methods inherited from class oracle.pg.hbase.OracleElement

      `getAttributes, getId, getProperty, getPropertyGraph, getPropertyKeys, isPartial, refresh, removeProperty, setPartial, setProperty, setPropertyCommon`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface oracle.pg.common.OracleElementBase

      `setPartial`

    - ### Methods inherited from interface com.tinkerpop.blueprints.Element

      `getId, getProperty, getPropertyKeys, removeProperty`

- - ### Method Detail

    - #### equals

          public boolean equals(Object o)

      This method returns true if the current OracleEdge instance is considered equal to the given OracleEdge instance
      Overrides:
        `equals` in class `Object`
      Parameters:
        `o` - an object to compare this edge against

    - #### forceRefresh

          public void forceRefresh()
                            throws Exception

      Physically refresh this Edge instance by reading from the underlying database
      Specified by:
        `forceRefresh` in interface `OracleElementBase`
      Specified by:
        `forceRefresh` in class `OracleElement`
      Throws:
        `Exception`

    - #### getInstance

          public static OracleEdge getInstance(OraclePropertyGraph opg,
                               Long eid)

      Returns an instance of OracleEdge
      Parameters:
        `opg` - the `OraclePropertyGraph` that the Edge belongs to.
        `eid` - the id for the Edge

    - #### getInstance

          public static OracleEdge getInstance(OraclePropertyGraph opg,
                               Long eid,
                               boolean bCreateIfAbsentFromCache)

      Returns an instance of OracleEdge. If there is no match in the cache and bCreateIfAbsentFromCache is false, then a NULL value will be returned.
      Parameters:
        `opg` - the `OraclePropertyGraph` that the Edge belongs to.
        `eid` - the id for the Edge
        `bCreateIfAbsentFromCache` - whether the Edge should be created or not if it is not found in the cache.

    - #### getInstance

          public static OracleEdge getInstance(OraclePropertyGraph opg,
                               Long eid,
                               boolean bCreateIfAbsentFromCache,
                               boolean bSkipStoreToCache)

      Returns an instance of OracleEdge. If there is no match in the cache and bCreateIfAbsentFromCache is false, then a NULL value will be returned.
      Parameters:
        `opg` - the `OraclePropertyGraph` that the Edge belongs to.
        `eid` - the id for the Edge
        `bCreateIfAbsentFromCache` - whether the Edge should be created or not if it is not found in the cache.
        `bSkipStoreToCache` - whether the Edge should be stored in the cache or not

    - #### getInstance

          public static OracleEdge getInstance(OraclePropertyGraph opg,
                               Long eid,
                               String label)

      Returns an instance of OracleEdge
      Parameters:
        `opg` - the `OraclePropertyGraph` that the Edge belongs to.
        `eid` - the id for the Edge
        `label` - the label for the Edge

    - #### getInstance

          public static OracleEdge getInstance(OraclePropertyGraph opg,
                               Long eid,
                               String label,
                               boolean bCreateIfAbsentFromCache)

      Returns an instance of OracleEdge. If there is no match in the cache and bCreateIfAbsentFromCache is false, then a NULL value will be returned.
      Parameters:
        `opg` - the `OraclePropertyGraph` that the Edge belongs to.
        `eid` - the id for the Edge
        `label` - the label for the Edge
        `bCreateIfAbsentFromCache` - whether the Edge should be created or not if it is not found in the cache.

    - #### getInstance

          public static OracleEdge getInstance(OraclePropertyGraph opg,
                               Long eid,
                               String label,
                               boolean bCreateIfAbsentFromCache,
                               boolean bSkipStoreToCache)

      Returns an instance of OracleEdge. If there is no match in the cache and bCreateIfAbsentFromCache is false, then a NULL value will be returned.
      Parameters:
        `opg` - the `OraclePropertyGraph` that the Edge belongs to.
        `eid` - the id for the Edge
        `label` - the label for the Edge
        `bCreateIfAbsentFromCache` - whether the Edge should be created or not if it is not found in the cache.
        `bSkipStoreToCache` - whether the Edge should be stored in the cache or not

    - #### getInstance

          public static OracleEdge getInstance(OraclePropertyGraph opg,
                               OracleVertexBase outVertex,
                               OracleVertexBase inVertex,
                               Long eid,
                               boolean bCreateIfAbsentFromCache,
                               boolean bSkipStoreToCache)

      Returns an instance of OracleEdge
      Parameters:
        `opg` - the `OraclePropertyGraph` that the Edge belongs to.
        `outVertex` - the outgoing Vertex of the Edge.
        `inVertex` - the incoming Vertex of the Edge.
        `eid` - the id for the Edge.
        `bCreateIfAbsentFromCache` - whether the Edge should be created or not if it is not found in the cache.
        `bSkipStoreToCache` - whether the Edge should be stored in the cache or not

    - #### getInstance

          public static OracleEdge getInstance(OraclePropertyGraph opg,
                               OracleVertexBase outVertex,
                               OracleVertexBase inVertex,
                               String edgeLabel,
                               Long eid)

      Returns an instance of OracleEdge
      Parameters:
        `opg` - the `OraclePropertyGraph` that the Edge belongs to.
        `outVertex` - the outgoing Vertex of the Edge.
        `inVertex` - the incoming Vertex of the Edge.
        `edgeLabel` - the label for the Edge.
        `eid` - the id for the Edge.

    - #### getInstance

          public static OracleEdge getInstance(OraclePropertyGraph opg,
                               OracleVertexBase outVertex,
                               OracleVertexBase inVertex,
                               String edgeLabel,
                               Long eid,
                               boolean bCreateIfAbsentFromCache)

      Returns an instance of OracleEdge
      Parameters:
        `opg` - the `OraclePropertyGraph` that the Edge belongs to.
        `outVertex` - the outgoing Vertex of the Edge.
        `inVertex` - the incoming Vertex of the Edge.
        `edgeLabel` - the label for the Edge.
        `eid` - the id for the Edge.
        `bCreateIfAbsentFromCache` - whether the Edge should be created or not if it is not found in the cache.

    - #### getInstance

          public static OracleEdge getInstance(OraclePropertyGraph opg,
                               OracleVertexBase outVertex,
                               OracleVertexBase inVertex,
                               String edgeLabel,
                               Long eid,
                               boolean bCreateIfAbsentFromCache,
                               boolean bSkipStoreToCache)

      Returns an instance of OracleEdge
      Parameters:
        `opg` - the `OraclePropertyGraph` that the Edge belongs to.
        `outVertex` - the outgoing Vertex of the Edge.
        `inVertex` - the incoming Vertex of the Edge.
        `edgeLabel` - the label for the Edge.
        `eid` - the id for the Edge.
        `bCreateIfAbsentFromCache` - whether the Edge should be created or not if it is not found in the cache.
        `bSkipStoreToCache` - whether the Edge should be stored in the cache or not

    - #### getInVertex

          public OracleVertex getInVertex()

      This is a bit more convenient than the getVertex API that uses Direction.

    - #### getInVertexID

          public Object getInVertexID()

      Return the incoming vertex Object.

    - #### getLabel

          public String getLabel()

      Return the label associated with the edge.
      Specified by:
        `getLabel` in interface `Edge`

    - #### getOutVertex

          public OracleVertex getOutVertex()

      This is a bit more convenient than the getVertex API that uses Direction.

    - #### getOutVertexID

          public Object getOutVertexID()

      Return the outgoing vertex Object.

    - #### getVertex

          public Vertex getVertex(Direction direction)

      Return the tail/out or head/in vertex.
      Specified by:
        `getVertex` in interface `Edge`

    - #### hashCode

          public int hashCode()

      This method returns the hash code
      Overrides:
        `hashCode` in class `Object`

    - #### remove

          public void remove()

      This method removes this OracleEdge instance from its owning OraclePropertyGraph instance
      Specified by:
        `remove` in interface `Element`

    - #### setProperty

          public void setProperty(String key,
                         Object value)

      Assign a key/value property to the element.
      Specified by:
        `setProperty` in interface `Element`
      Overrides:
        `setProperty` in class `OracleElement`
      Parameters:
        `key` - key of an attribute (K/V pair)
        `value` - value of an attribute (K/V pair)

    - #### setProperty

          public void setProperty(String key,
                         Object value,
                         boolean skipQueue)

      Assign a key/value property to the element.
      Specified by:
        `setProperty` in interface `OracleElementBase`
      Overrides:
        `setProperty` in class `OracleElement`
      Parameters:
        `key` - key of the attribute (K/V)
        `value` - value of the attribute (K/V)
        `skipQueue` - when true, then this K/V pair change will not cause this Element to be put in the update queue.

    - #### toString

          public String toString()

      Returns a String representation of the Edge
      Overrides:
        `toString` in class `Object`

Copyright © 2015 Oracle and/or its affiliates. All Rights Reserved.